All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # This program is licensed under the GNU GPL version 2 or later.
4 # (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2013
5 # For details, see LICENSE. To submit patches, you have to agree to
6 # license your code under the GNU GPL version 2 or later.
8 # While the following is not legally binding, the author would like to
9 # explain the choice of GPLv2+ over GPLv3+.
10 # The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
11 # full compatibility's with Git. In case Git ever changes its licensing terms,
12 # which is admittedly extremely unlikely to the point of being impossible,
13 # this software will most likely follow suit.
15 # This should always be the first line of code to facilitate debugging
16 [ -n "$VCSH_DEBUG" ] && set -vx
19 # If '.git-HEAD' is appended to the version, you are seeing an unreleased
20 # version of vcsh; the master branch is supposed to be clean at all times
21 # so you can most likely just use it nonetheless
22 VERSION='1.20131229.git-HEAD'
26 echo "$SELF: fatal: $1" >&2
30 # We need to run getops as soon as possible so we catch -d and other
31 # options that will modify our behaviour.
32 # Commands are handled at the end of this script.
33 while getopts "c:dv" flag; do
34 if [ "$1" = '-d' ] || [ "$1" = '--debug' ]; then
39 elif [ "$1" = '-v' ]; then
41 echo "verbose mode on"
43 elif [ "$1" = '-c' ]; then
44 VCSH_OPTION_CONFIG=$OPTARG
50 # Source file even if it's in $PWD and does not have any slashes in it
58 # Read configuration and set defaults if anything's not set
59 [ -n "$VCSH_DEBUG" ] && set -vx
60 : ${XDG_CONFIG_HOME:=$HOME/.config}
62 # Read configuration files if there are any
63 [ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
64 [ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
65 if [ -n "$VCSH_OPTION_CONFIG" ]; then
66 # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
67 if [ -r "$VCSH_OPTION_CONFIG" ]; then
68 source_all "$VCSH_OPTION_CONFIG"
70 fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
73 [ -n "$VCSH_DEBUG" ] && set -vx
76 : ${VCSH_REPO_D:=$XDG_CONFIG_HOME/vcsh/repo.d}
77 : ${VCSH_HOOK_D:=$XDH_CONFIG_HOME/vcsh/hooks-enabled}
79 : ${VCSH_GITIGNORE:=exact}
80 : ${VCSH_WORKTREE:=absolute}
82 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
83 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
86 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ] && [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
87 fatal "'\$VCSH_WORKTREE' must equal 'absolute', or 'relative'" 1
92 echo "usage: $SELF <options> <command>
97 -v Enable verbose mode
101 [<repo>] Clone from an existing repository
102 commit Commit in all repositories
103 delete <repo> Delete an existing repository
104 enter <repo> Enter repository; spawn new instance of \$SHELL
105 help Display this help text
106 init <repo> Initialize a new repository
107 list List all repositories
108 list-tracked List all files tracked by vcsh
110 <repo> List files tracked by a repository
111 pull Pull from all vcsh remotes
112 push Push to vcsh remotes
114 <newname> Rename repository
116 <command> Use this repository
117 status [<repo>] Show statuses of all/one vcsh repositories
118 upgrade <repo> Upgrade repository to currently recommended settings
119 version Print version information
120 which <substring> Find substring in name of any tracked file
122 <repo> Write .gitignore.d/<repo> via git ls-files
124 <repo> <git command> Shortcut to run git commands directly
125 <repo> Shortcut to enter repository" >&2
129 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
133 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
137 echo "$SELF: error: $1" >&2
141 echo "$SELF: info: $1"
147 git remote add origin "$GIT_REMOTE"
148 git config branch.master.remote origin
149 git config branch.master.merge refs/heads/master
150 if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
151 info "remote is empty, not merging anything"
155 for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
157 error "'$object' exists." &&
160 [ "$VCSH_CONFLICT" = '1' ] &&
161 fatal "will stop after fetching and not try to merge!
162 Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning." 17
163 git merge origin/master
166 hook post-clone-retired
171 for VCSH_REPO_NAME in $(list); do
172 echo "$VCSH_REPO_NAME: "
173 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
175 git commit --untracked-files=no --quiet
182 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
184 info "This operation WILL DESTROY DATA!"
185 files=$(git ls-files)
186 echo "These files will be deleted:
190 AGAIN, THIS WILL DELETE YOUR DATA!
191 To continue, type 'Yes, do as I say'"
193 [ "x$answer" = 'xYes, do as I say' ] || exit 16
194 for file in $files; do
195 rm -f $file || info "could not delete '$file', continuing with deletion"
197 rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
208 [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
212 for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
213 [ -x "$hook" ] || continue
214 verbose "executing '$hook'"
221 [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
222 mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
223 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
224 git init --shared=0600
230 for repo in "$VCSH_REPO_D"/*.git; do
231 [ -d "$repo" ] && [ -r "$repo" ] && echo $(basename "$repo" .git)
236 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
241 for VCSH_REPO_NAME in $(list); do
248 git ls-files | sort -u
253 for VCSH_REPO_NAME in $(list); do
254 printf "$VCSH_REPO_NAME: "
255 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
265 for VCSH_REPO_NAME in $(list); do
266 printf "$VCSH_REPO_NAME: "
267 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
281 [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
282 mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
284 # Now that the repository has been renamed, we need to fix up its configuration
285 # Overwrite old name..
286 GIT_DIR="$GIT_DIR_NEW"
287 VCSH_REPO_NAME="$VCSH_REPO_NAME_NEW"
288 # ..and clobber all old configuration
300 if [ ! "x$VCSH_REPO_NAME" = "x" ]; then
301 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
303 git status --short --untracked-files='no'
305 for VCSH_REPO_NAME in $(list); do
306 echo "$VCSH_REPO_NAME:"
307 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
309 git status --short --untracked-files='no'
317 # fake-bare repositories are not bare, actually. Set this to false
318 # because otherwise Git complains "fatal: core.bare and core.worktree
320 git config core.bare false
321 # core.worktree may be absolute or relative to $GIT_DIR, depending on
323 if [ ! "x$VCSH_WORKTREE" = 'xabsolute' ]; then
324 git config core.worktree $(cd $GIT_DIR && GIT_WORK_TREE="$VCSH_BASE" git rev-parse --show-cdup)
325 elif [ ! "x$VCSH_WORKTREE" = 'xrelative' ]; then
326 git config core.worktree "$VCSH_BASE"
328 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
329 git config vcsh.vcsh 'true'
331 [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
337 export VCSH_DIRECTORY="$VCSH_REPO_NAME"
341 for VCSH_REPO_NAME in $(list); do
342 for VCSH_FILE in $(get_files); do
343 echo $VCSH_FILE | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
349 # Don't do anything if the user does not want to write gitignore
350 if [ "x$VCSH_GITIGNORE" = 'xnone' ]; then
351 info "Not writing gitignore as '\$VCSH_GITIGNORE' is set to 'none'"
356 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
357 gitignores=$(for file in $(git ls-files); do
359 echo $file; new="${file%/*}"
360 [ "$file" = "$new" ] && break
365 # Contrary to GNU mktemp, mktemp on BSD/OSX requires a template for temp files
366 # Using a template makes GNU mktemp default to $PWD and not #TMPDIR for tempfile location
367 # To make every OS happy, set full path explicitly
368 tempfile=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal "could not create tempfile: '${tempfile}'" 51
370 echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
371 for gitignore in $gitignores; do
372 echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
373 if [ "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ -d "$gitignore" ]; then
374 { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
377 if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
378 rm -f "$tempfile" || error "could not delete '$tempfile'"
381 if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
382 info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
383 mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
384 fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
386 mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
387 fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
392 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
393 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
396 export VCSH_COMMAND="$1"
398 case "$VCSH_COMMAND" in
399 clon|clo|cl) VCSH_COMMAND=clone;;
400 commi|comm|com|co) VCSH_COMMAND=commit;;
401 delet|dele|del|de) VCSH_COMMAND=delete;;
402 ente|ent|en) VCSH_COMMAND=enter;;
403 hel|he) VCSH_COMMAND=help;;
404 ini|in) VCSH_COMMAND=init;;
405 pul) VCSH_COMMAND=pull;;
406 pus) VCSH_COMMAND=push;;
407 renam|rena|ren|re) VCSH_COMMAND=rename;;
408 ru) VCSH_COMMAND=run;;
409 statu|stat|sta|st) VCSH_COMMAND=status;;
410 upgrad|upgra|upgr|up) VCSH_COMMAND=upgrade;;
411 versio|versi|vers|ver|ve) VCSH_COMMAND=version;;
412 which|whi|wh) VCSH_COMMAND=which;;
413 write|writ|wri|wr) VCSH_COMMAND=write-gitignore;;
416 if [ "$VCSH_COMMAND" = 'clone' ]; then
417 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
419 [ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
420 [ -z "$VCSH_REPO_NAME" ] && fatal "$VCSH_COMMAND: could not determine repository name" 1
421 export VCSH_REPO_NAME
422 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
423 elif [ "$VCSH_COMMAND" = 'version' ]; then
424 echo "$SELF $VERSION"
427 elif [ "$VCSH_COMMAND" = 'which' ]; then
428 [ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a filename" 1
429 [ -n "$3" ] && fatal "$VCSH_COMMAND: too many parameters" 1
430 export VCSH_COMMAND_PARAMETER="$2"
431 elif [ "$VCSH_COMMAND" = 'delete' ] ||
432 [ "$VCSH_COMMAND" = 'enter' ] ||
433 [ "$VCSH_COMMAND" = 'init' ] ||
434 [ "$VCSH_COMMAND" = 'list-tracked-by' ] ||
435 [ "$VCSH_COMMAND" = 'rename' ] ||
436 [ "$VCSH_COMMAND" = 'run' ] ||
437 [ "$VCSH_COMMAND" = 'upgrade' ] ||
438 [ "$VCSH_COMMAND" = 'write-gitignore' ]; then
439 [ -z $2 ] && fatal "$VCSH_COMMAND: please specify repository to work on" 1
440 [ "$VCSH_COMMAND" = 'rename' -a -z "$3" ] && fatal "$VCSH_COMMAND: please specify a target name" 1
441 [ "$VCSH_COMMAND" = 'run' -a -z "$3" ] && fatal "$VCSH_COMMAND: please specify a command" 1
442 export VCSH_REPO_NAME="$2"
443 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
444 [ "$VCSH_COMMAND" = 'rename' ] && { export VCSH_REPO_NAME_NEW="$3";
445 export GIT_DIR_NEW="$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git"; }
446 [ "$VCSH_COMMAND" = 'run' ] && shift 2
447 elif [ "$VCSH_COMMAND" = 'commit' ] ||
448 [ "$VCSH_COMMAND" = 'list' ] ||
449 [ "$VCSH_COMMAND" = 'list-tracked' ] ||
450 [ "$VCSH_COMMAND" = 'pull' ] ||
451 [ "$VCSH_COMMAND" = 'push' ]; then
453 elif [ "$VCSH_COMMAND" = 'status' ]; then
454 export VCSH_REPO_NAME="$2"
455 elif [ -n "$2" ]; then
456 export VCSH_COMMAND='run'
457 export VCSH_REPO_NAME="$1"
458 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
459 [ -d $GIT_DIR ] || { help; exit 1; }
462 elif [ -n "$VCSH_COMMAND" ]; then
463 export VCSH_COMMAND='enter'
464 export VCSH_REPO_NAME="$1"
465 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
466 [ -d $GIT_DIR ] || { help; exit 1; }
468 # $1 is empty, or 'help'
472 # Did we receive a directory instead of a name?
473 # Mangle the input to fit normal operation.
474 if echo $VCSH_REPO_NAME | grep -q '/'; then
475 export GIT_DIR=$VCSH_REPO_NAME
476 export VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git)
481 if [ ! -d "$check_directory" ]; then
482 if [ -e "$check_directory" ]; then
483 fatal "'$check_directory' exists but is not a directory" 13
485 verbose "attempting to create '$check_directory'"
486 mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
491 check_dir "$VCSH_REPO_D"
492 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && check_dir "$VCSH_BASE/.gitignore.d"
494 verbose "$VCSH_COMMAND begin"
495 export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
499 verbose "$VCSH_COMMAND end, exiting"